package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import java.util.stream.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class OIVPUPDT_OIVPM05I {
    public @Getter @Builder.Default String FILLER1 = StringUtils
            .repeat(' ', 12);
    public @Getter @Setter int DATEL;
    public @Getter @Builder.Default String DATEF = StringUtils.repeat(' ', 1);

    public String getDATEA() {
        return DATEF;
    }

    public void setDATEA(String var) {
        DATEF = var;
    }

    public @Getter @Builder.Default String DATEI = StringUtils.repeat(' ', 8);
    public @Getter @Setter int TERML;
    public @Getter @Builder.Default String TERMF = StringUtils.repeat(' ', 1);

    public String getTERMA() {
        return TERMF;
    }

    public void setTERMA(String var) {
        TERMF = var;
    }

    public @Getter @Builder.Default String TERMI = StringUtils.repeat(' ', 4);
    public @Getter @Setter int TIMEL;
    public @Getter @Builder.Default String TIMEF = StringUtils.repeat(' ', 1);

    public String getTIMEA() {
        return TIMEF;
    }

    public void setTIMEA(String var) {
        TIMEF = var;
    }

    public @Getter @Builder.Default String TIMEI = StringUtils.repeat(' ', 8);
    public @Getter @Setter int IDENL;
    public @Getter @Builder.Default String IDENF = StringUtils.repeat(' ', 1);

    public String getIDENA() {
        return IDENF;
    }

    public void setIDENA(String var) {
        IDENF = var;
    }

    public @Getter @Builder.Default String IDENI = StringUtils.repeat(' ', 8);
    public @Getter @Setter int NAMEL;
    public @Getter @Builder.Default String NAMEF = StringUtils.repeat(' ', 1);

    public String getNAMEA() {
        return NAMEF;
    }

    public void setNAMEA(String var) {
        NAMEF = var;
    }

    public @Getter @Builder.Default String NAMEI = StringUtils.repeat(' ', 40);
    public @Getter @Setter int DEPTL;
    public @Getter @Builder.Default String DEPTF = StringUtils.repeat(' ', 1);

    public String getDEPTA() {
        return DEPTF;
    }

    public void setDEPTA(String var) {
        DEPTF = var;
    }

    public @Getter @Builder.Default String DEPTI = StringUtils.repeat(' ', 40);
    public @Getter @Setter int PHONL;
    public @Getter @Builder.Default String PHONF = StringUtils.repeat(' ', 1);

    public String getPHONA() {
        return PHONF;
    }

    public void setPHONA(String var) {
        PHONF = var;
    }

    public @Getter @Builder.Default String PHONI = StringUtils.repeat(' ', 40);
    public @Getter @Setter int EMALL;
    public @Getter @Builder.Default String EMALF = StringUtils.repeat(' ', 1);

    public String getEMALA() {
        return EMALF;
    }

    public void setEMALA(String var) {
        EMALF = var;
    }

    public @Getter @Builder.Default String EMALI = StringUtils.repeat(' ', 40);
    public @Getter @Setter int ADDRL;
    public @Getter @Builder.Default String ADDRF = StringUtils.repeat(' ', 1);

    public String getADDRA() {
        return ADDRF;
    }

    public void setADDRA(String var) {
        ADDRF = var;
    }

    public @Getter @Builder.Default String ADDRI = StringUtils.repeat(' ', 40);
    public @Getter @Setter int MSGL;
    public @Getter @Builder.Default String MSGF = StringUtils.repeat(' ', 1);

    public String getMSGA() {
        return MSGF;
    }

    public void setMSGA(String var) {
        MSGF = var;
    }

    public @Getter @Builder.Default String MSGI = StringUtils.repeat(' ', 76);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public void setFILLER1(String source) {
        FILLER1 = StringUtils.truncate(StringUtils.rightPad(source, 12), 12);
    }

    public String getStringDATEL() {
        return intFormatWithSign.apply((long) DATEL, "0000");
    }

    public void setDATEF(String source) {
        DATEF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setDATEI(String source) {
        DATEI = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringTERML() {
        return intFormatWithSign.apply((long) TERML, "0000");
    }

    public void setTERMF(String source) {
        TERMF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setTERMI(String source) {
        TERMI = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public String getStringTIMEL() {
        return intFormatWithSign.apply((long) TIMEL, "0000");
    }

    public void setTIMEF(String source) {
        TIMEF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setTIMEI(String source) {
        TIMEI = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringIDENL() {
        return intFormatWithSign.apply((long) IDENL, "0000");
    }

    public void setIDENF(String source) {
        IDENF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setIDENI(String source) {
        IDENI = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringNAMEL() {
        return intFormatWithSign.apply((long) NAMEL, "0000");
    }

    public void setNAMEF(String source) {
        NAMEF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setNAMEI(String source) {
        NAMEI = StringUtils.truncate(StringUtils.rightPad(source, 40), 40);
    }

    public String getStringDEPTL() {
        return intFormatWithSign.apply((long) DEPTL, "0000");
    }

    public void setDEPTF(String source) {
        DEPTF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setDEPTI(String source) {
        DEPTI = StringUtils.truncate(StringUtils.rightPad(source, 40), 40);
    }

    public String getStringPHONL() {
        return intFormatWithSign.apply((long) PHONL, "0000");
    }

    public void setPHONF(String source) {
        PHONF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setPHONI(String source) {
        PHONI = StringUtils.truncate(StringUtils.rightPad(source, 40), 40);
    }

    public String getStringEMALL() {
        return intFormatWithSign.apply((long) EMALL, "0000");
    }

    public void setEMALF(String source) {
        EMALF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setEMALI(String source) {
        EMALI = StringUtils.truncate(StringUtils.rightPad(source, 40), 40);
    }

    public String getStringADDRL() {
        return intFormatWithSign.apply((long) ADDRL, "0000");
    }

    public void setADDRF(String source) {
        ADDRF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setADDRI(String source) {
        ADDRI = StringUtils.truncate(StringUtils.rightPad(source, 40), 40);
    }

    public String getStringMSGL() {
        return intFormatWithSign.apply((long) MSGL, "0000");
    }

    public void setMSGF(String source) {
        MSGF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setMSGI(String source) {
        MSGI = StringUtils.truncate(StringUtils.rightPad(source, 76), 76);
    }

    public static OIVPUPDT_OIVPM05I createDefaultValueInstance() {
        return new OIVPUPDT_OIVPM05I.builder().build();
    }

    @Override
    public String toString() {
        return FILLER1 + String.valueOf(getDATEL()) + getDATEF() + getDATEI()
                + String.valueOf(getTERML()) + getTERMF() + getTERMI()
                + String.valueOf(getTIMEL()) + getTIMEF() + getTIMEI()
                + String.valueOf(getIDENL()) + getIDENF() + getIDENI()
                + String.valueOf(getNAMEL()) + getNAMEF() + getNAMEI()
                + String.valueOf(getDEPTL()) + getDEPTF() + getDEPTI()
                + String.valueOf(getPHONL()) + getPHONF() + getPHONI()
                + String.valueOf(getEMALL()) + getEMALF() + getEMALI()
                + String.valueOf(getADDRL()) + getADDRF() + getADDRI()
                + String.valueOf(getMSGL()) + getMSGF() + getMSGI();
    }
}
